%writehb		Write a sparse matrix in Harwell-Boeing format
%
%usage : writehb( A, file [,double] )
%
%A      = sparse matrix to write to file
%file   = filename
%double = 0 for single precision (default) , 1 for double
%
%Note : This needs the m2hbo or m2hbodouble executable in the PATH 
%       and will create a temporary file in the /tmp directory.

function writehb( A, file, double )

if nargin<3
  double=0;
end

if ~issparse(A)
  disp('Warning, matrix A is not sparse, writing in sparse format anyway')
  A=sparse(A);
end

tmpfile=['/tmp/tmp_writehb_',num2str(floor(rand*10000))];
bindir=strrep(which('readhb'),'readhb.m','');

if double
  eval(['save ',tmpfile,' A -ascii -double'])
  eval(['!',bindir,'m2hbodouble < ',tmpfile,' > ',file]);
else
  eval(['save ',tmpfile,' A -ascii'])
  eval(['!',bindir,'m2hbo < ',tmpfile,' > ',file]);
end
delete(tmpfile);

